# -*- coding:utf-8 -*-

__author__ = 'weijie'

from EmQuantAPI import *
from datetime import timedelta, datetime
from time import sleep
import traceback
import requests
import re
from dbOperationStock import dbOperationStock
import db_config
import json

def cnqCallback(quantdata):
    url = 'http://taifooksec.com/api/news/batchAddNews.do'
    newsList = []
    for code in quantdata.Data:
        for k in range(0, len(quantdata.Data[code])):
            se = requests.session()
            url = "http://app.jg.eastmoney.com/NewsData/GetNewsText.do?cid=Admin&cid=Admin&id=" + quantdata.Data[code][k][5]
            dfNews = se.post(url).text.replace("'", '"').replace('/ ', '/')
            dfNew = eval(dfNews)
            content = str(dfNew['text']).replace("<a","<span").replace("/a>","/span>")
            pattern = 'https://z1.*?\.jpg'
            p2 = re.findall(pattern, str(content))
            imgUrl = "http://taifooksec.com/public/default.png"
            if(0 != len(p2)) :
                imgUrl = p2[0]
            news = {}
            news['title'] = str(dfNew['Title'])
            news['cover'] = str(imgUrl)
            news['content'] = str(content)
            news['source'] = str(dfNew['medianame'])
            news['hot'] = "0"
            news['publishTime'] = str(dfNew['Date'])
            newsList.append(news)
    headers = {'Content-Type': 'application/json'}
    response = requests.post(url=url, headers=headers, data=json.dumps(newsList))

class LimitUpNewsData:

    def toGet(self):
        try:
            data = c.cnq("S888005002API,S888005003API,S888005004API,S888005005API,S888005010API,S888005008API,S888005009API","sectornews","",cnqCallback)
            if data.ErrorCode != 0:
                print("request cnq Error, ", data.ErrorMsg)
            else:
                print("cnq输出结果======分隔线======")
        except Exception as ee:
            print("error >>>",ee)
            traceback.print_exc()
        else:
            print("demo end")
